package com.zswc.creativity.utils

import java.util.*

/**
 *Created by shihuiyun
 *on 2020/9/16
 */
object RandomUtils {
    val LETTER_NUMBER = charArrayOf('a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k',
            'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z',
            '0', '1', '2', '3', '4', '5', '6', '7', '8', '9')

    val LETTER = charArrayOf('a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k',
            'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z')

    val NUMBER = charArrayOf('0', '1', '2', '3', '4', '5', '6', '7', '8', '9')

    /**
     * 按指定大小在**26个英文字母**中生成随机数。
     *
     * @param t 生成的长度，t不能小于1或大于99，否则返回"0"
     *
     * @return 你想要的随机数
     *
     * @created 2013-5-16 下午02:40:05
     * @author Belen
     */
    fun getRandomOfLetter(t: Int): String? {
        return get(LETTER, t)
    }

    /**
     * 按指定大小在**0-9**数字中生成随机数。
     *
     * @param t 生成的长度，t不能小于1或大于99，否则返回"0"
     *
     * @return 你想要的随机数
     *
     * @created 2013-5-16 下午02:40:05
     * @author Belen
     */
    fun getRandomOfNumber(t: Int): String? {
        return get(NUMBER, t)
    }

    /**
     * 按指定大小在**25个英文以及10个数字**中生成随机数。
     *
     * @param t 生成的长度，t不能小于1或大于99，否则返回"0"
     *
     * @return 你想要的随机数
     *
     * @created 2013-5-16 下午02:40:05
     * @author Belen
     */
    fun getRandomOfLetterAndNumber(t: Int): String? {
        return get(LETTER_NUMBER, t)
    }

    /**
     * 按指定数组生成数据。
     */
    private operator fun get(c: CharArray, t: Int): String? {
        if (t < 1 || t > 99) {
            return "0"
        }
        val maxNum = 36
        var i: Int // 生成的随机数
        var count = 0 // 生成的长度
        val sb = StringBuffer("")
        val r = Random()
        while (count < t) {
            // 生成随机数，取绝对值，防止生成负数，
            i = Math.abs(r.nextInt(maxNum)) // 生成的数最大为36-1
            if (i >= 0 && i < c.size) {
                sb.append(c[i])
                count++
            }
        }
        return sb.toString()
    }
}
